<?php

##########################################################
############ ---===> INITIALIZE STUFF <===--- ############
##########################################################

################## MAGIC QUOTES REMOVAL ##################
if (get_magic_quotes_gpc()) {
	function strip_magic_quotes_gpc(&$var) {
		foreach($var AS $key => $value) {
			if (is_array($var[$key])) {
				strip_magic_quotes_gpc($var[$key]);
			} else {
				$var[$key] = stripslashes($var[$key]);
			}
		}
	}
	strip_magic_quotes_gpc($_GET);
	strip_magic_quotes_gpc($_POST);
	strip_magic_quotes_gpc($_REQUEST);
	//	strip_magic_quotes_gpc($_COOKIE); Maybe later or if this is used somewhere else :)
}

####################### DATA SCHEMES #####################
$en_newsscheme    = 'date,author,title,text,time,commentid,email';
$en_commentscheme = 'author,email,date,time,text,ip';
$en_designscheme  = 'background,bordercolor,bg_newstitle,bg_datetime,bg_newstext,bg_comment,bg_form,tc_commentform,commentline,tc_newstitle,tc_author,tc_datetime,tc_newstext,tc_comments,linkcolor,lc_mouseover,tc_other,sb_face,sb_shadow,sb_highlight,sb_3dlight,sb_darkshadow,sb_track,sb_arrow,innerborder,outerborder';

##########################################################
############### ---===> CONSTANTS <===--- ################
##########################################################

################## NEWS DISPLAY CONSTANTS ################
define('NEWS_ADDHEADER', 1);
define('NEWS_ADDFOOTER', 2);
define('NEWS_ADDMORELINK', 4);
define('NEWS_SHOWICONS', 8);
define('NEWS_ALLOPTIONS', 255);
define('NEWS_SHOWFULL', NEWS_ALLOPTIONS - NEWS_ADDMORELINK);

################### PERMISSION CONSTANTS #################

// single permissions
define ('ADMIN_DESIGN', 1);
define ('ADMIN_DELETECOMMENTS', 2);
define ('ADMIN_IP', 4);
define ('ADMIN_ADDNEWS', 8);
define ('ADMIN_EDITNEWS', 16);

// combined permissions
define ('ADMIN_COMMENTS', ADMIN_DELETECOMMENTS + ADMIN_IP);
define ('ADMIN_NEWS', ADMIN_ADDNEWS + ADMIN_EDITNEWS);
define ('ADMIN_ALL', 255);

##########################################################
############### ---===> FUNCTIONS <===--- ################
##########################################################

################# FUNCTION en_strip_tags #################
function en_strip_tags ($string) {
	// ok, though its not completely tested, it should strip most of the tags and should let most of the rest alone
	return preg_replace("#<!--.*--\s*>|</?[a-z][\w-]*\s*(?:[\w-]+\s*=\s*([\"']).*\\1\s*|[\w-]+\s*=\s*[^>\s\"']*|[\w-]+\s*)*\s*/?>#Usi", '', $string);
}

################# FUNCTION en_checklogin #################
function en_checklogin($permissions) {
	global $adminlogin;
	$pass = $_POST['password'];
	return (isset($adminlogin[$pass]) AND ($adminlogin[$pass] & $permissions));
}

############### FUNCTION file_get_contents ###############
if (!function_exists('file_get_contents')) {
	function file_get_contents($filename, $use_include_path = 0) {
		$file = @fopen($filename, 'rb', $use_include_path);
		if ($file) {
			if ($fsize = @filesize($filename)) {
				$data = fread($file, $fsize);
			} else {
				$data = ''; // just to be safe. Dunno, if this is really needed
				while (!feof($file)) $data .= fread($file, 1024);
			}
			fclose($file);
		}
		return $data;
	}
}

################# FUNCTION en_showmessage ################
function en_showmessage($text) {
	eval('echo "' . en_gettemplate('standardmessage') . '";');
}

########### FUNCTION en_htmlentities_leavetags ###########
function en_htmlentities_leavetags($text) {
	$table = get_html_translation_table(HTML_ENTITIES, ENT_NOQUOTES);
	unset($table['<']);
	unset($table['>']);
	return strtr($text, $table);
}

###################### FUNCTION save #####################
function save($path, $data) {
	$fp = fopen($path, 'w');
	fwrite($fp, $data);
	fclose($fp);
}

################### FUNCTION en_getdata ##################
function en_getdata($line, $scheme) {
	$line = explode(',', $line);
	$scheme = explode(',', $scheme);
	$i = 0;
	foreach($scheme AS $part)
		$data[$part] = $line[$i++];
	return $data;
}

################## FUNCTION en_makedata ##################
function en_makedata($array, $scheme) {
	$scheme = explode(',', $scheme);
	$i = 0;
	foreach($scheme AS $part)
	$line[$i++] = $array[$part];
	return implode(',', $line);
}

################### FUNCTION en_implode ##################
function en_implode($array) {
	foreach ($array AS $line)
		$string .= ($line != '') ? chop($line) . "\n" : '';
	return $string;
}

################### FUNCTION en_getcid ###################
function en_getcid($id) {
	global $en_paths, $en_newsscheme;
	$line = file($en_paths['newsfile']);
	$linen = sizeof($line);
	$idb = $linen - $id;
	if(($line[$idb] != '') AND ($line[$idb] != "\n")) {
		$news = en_getdata(chop($line[$idb]), $en_newsscheme);
		$cid = chop($news['commentid']);
	}
	return $cid;
}

################# FUNCTION en_gettemplate ################
function en_gettemplate($name, $slashes = 1) {
	global $en_paths, $template;
	if ($template[$name] == '') {
		$templatefile = $en_paths['templates'] . '/' . $name . '.html';
		if (!file_exists($templatefile))
			die('Template ' . $templatefile . ' not found');
		$template[$name] = implode('', file($templatefile));
	}
	return $slashes ? str_replace("\\'", "'", addslashes($template[$name])) : $template[$name];
}

################# FUNCTION en_getformdata ################
function en_getformdata($scheme) {
	// returns 'valid' POST-Data depending on the specified scheme and returns is as an array
	$parts = explode(',', $scheme);
	foreach ($parts AS $part)
		$returnarray[$part] = $_POST[$part];
	return $returnarray;
}

################# FUNCTION en_savedesign #################
function en_savedesign($path) {
	global $design, $en_designscheme;
	$data = '<' . '?php

$design = array (';

	$parts = explode(',', $en_designscheme);
	foreach ($parts AS $part) {
		$designvalue = str_replace("'","\\'", addslashes($design[$part]));
		$line[] = "\n\t'$part'" . str_repeat(' ', 14 - strlen($part)) . " => '$designvalue'";
	}
	$data .= implode(',', $line);
	$data .= '
);

?' . '>';
	save($path, $data);
}

#################### FUNCTION en_nl2br ###################
function en_nl2br($text) {
	$text = str_replace("\r", strstr($text, "\n") ? '' : "\n", $text); // Change all linebreaks to linux-style linebreaks
	return str_replace("\n", '<br />', $text);
}

################# FUNCTION en_unwordwrap #################
function en_unwordwrap($text)
{
	return str_replace('  ', '', $text);
}

################ FUNCTION en_url2htmllink ################
function en_url2htmllink($url)
{
	// create an HTML-Link from a URL and shorten the linktext, if necessary
	$url = en_unwordwrap($url);
	$linktext = (strlen($url) > 43 ? substr($url, 0, 25) . '...' . substr($url, -15) : $url);
	return '<a href="' . $url . '" target="_blank">'. $linktext . '</a>';
}

##################### FUNCTION bbcode ####################
function bbcode($entry) {
	global $en_paths, $en_smilies;

	// Smilies einbauen
	if (SCRIPT_FILENAME != 'print.php') {
		$entry = preg_replace('/mailto:/i', 'mailto&#58;', $entry); // Fix for the smilie-function
		$entry = strtr($entry, $en_smilies);
	}

	// BBCodes replace

	// Searchpattern
	$patterns = array (
		"#\[b\](.+)\[/b\]#Uis",
		"#\[i\](.+)\[/i\]#Uis",
		"#\[u\](.+)\[/u\]#Uis",
		"#\[left\](.+)\[/left\]#Uis",
		"#\[center\](.+)\[/center\]#Uis",
		"#\[right\](.+)\[/right\]#Uis",
		"#\[img\](.+)\[/img\]#Uis",
		"#\[(e?)mail\](.+)\[/\\1mail\]#Uis",
		"#\[(e?)mail=(&quot;|\"|'|)(.+)\\2](.+)\[/\\1mail\]#Uis",
		"#\[url=(&quot;|\"|'|)(.+)\\1](.+)\[/url\]#Uise",
		"#\[font=(&quot;|\"|'|)(.+)\\1](.+)\[/font\]#Uis",
		"#\[size=(&quot;|\"|'|)([0-9]+)\\1](.+)\[/size\]#Uis",
		"#\[url\](.+)\[/url\]#Uise"
	);

	// Compensationpattern
	$replacements = array (
		'<b>\\1</b>',
		'<i>\\1</i>',
		'<u>\\1</u>',
		'<div align="left">\\1</div>',
		'<div align="center">\\1</div>',
		'<div align="right">\\1</div>',
		'<img src="\\1" border="0" alt="" />',
		'<a href="mailto:\\2">\\2</a>',
		'<a href="mailto:\\3">\\4</a>',
		'"<a href=\"" . en_unwordwrap("\\2") . "\" target=\"_blank\">\\3</a>"',
		'<font face="\\2">\\3</font>',
		'<font size="\\2">\\3</font>',
		'en_url2htmllink("\\1")'
	);

	return preg_replace($patterns, $replacements, $entry);
}

################## FUNCTION getlinktext ##################
function getlinktext($linktext, $pagenumber) {
	eval ('$link = "' . $linktext . '";');
	return $link;
}

##################### FUNCTION pages #####################
function pages($entrys, $page, $pagediff, $perpage, $linktext, $multiply_pagenum = 1, $highlightactive = 1, $nextpagelink = 1) {
	// begin number of pages
	// hack by devnul, www.fahrvergnuegen.at/easynews
	// modified by Christian Stadler, www.ragnarokonline.de
	$pages = ceil($entrys / $perpage);
	if ($multiply_pagenum) {
		$first = 0;
		$last  = ($pages - 1) * $perpage;
		$next  = $page * $perpage;
		$back  = ($page - 2) * $perpage;
	} else {
		$first = 1;
		$last  = $pages;
		$next  = $page + 1;
		$back  = $page - 1;
	}
	$beginpage = $page - $pagediff;
	if ($beginpage <= 0) $beginpage = 1;
	$endpage = $page + $pagediff;
	if ($endpage > $pages) $endpage = $pages;
	if ($pages >= 1) {
		$pagestext = 'Seiten: ';
		if ($beginpage > 1) $pagestext .= '<a title="erste Seite" href="' . getlinktext($linktext, $first) . '"><b>&laquo;</b></a> ';
		if ($page > 1) $pagestext .= '<a title="vorherige Seite" href="' . getlinktext($linktext, $back) . '"><b>&lsaquo;</b></a> ';
		for ($pagenumber = $beginpage; $pagenumber <= $endpage; $pagenumber++) {
			$openpage = $multiply_pagenum ? ($pagenumber - 1) * $perpage : $pagenumber;
			$pagestext .= ($pagenumber == $page && $highlightactive) ? '<b>' . $pagenumber . '</b> ' : '<a href="' . getlinktext($linktext, $openpage) . '">' . $pagenumber . '</a> ';
		}
		if ($page < $pages && $nextpagelink) $pagestext .= '<a title="next page" href="' . getlinktext($linktext, $next) . '"><b>&rsaquo;</b></a>';
		if ($endpage < $pages) $pagestext .= ' <a title="last page" href="' . getlinktext($linktext, $last) . '"><b>&raquo;</b></a>';
	}
	// end number of pages
	return $pagestext;
}

############## FUNCTION en_createcommentdata #############
function en_createcommentdata($comment, $in_form = false) {
	$comment['date']   = date('F dS, Y');
	$comment['time']   = date('h:i A');
	$comment['ip']     = $_SERVER['REMOTE_ADDR'];
	if (!$in_form) {
		$comment['text']   = en_nl2br($comment['text']);
		$comment['date']   = str_replace(',', '&komma;', $comment['date']);
		$comment['text']   = str_replace(',', '&komma;', $comment['text']);
		$comment['email']  = str_replace(',', '&komma;', $comment['email']);
		$comment['author'] = str_replace(',', '&komma;', $comment['author']);
	} else {
		$comment['email']  = str_replace('"', '&quot;', $comment['email']);
		$comment['author'] = str_replace('"', '&quot;', $comment['author']);
	}
	return $comment;
}

############### FUNCTION en_createnewsdata ###############
function en_createnewsdata($news, $in_form = false, $do_edit_news = false) {
	$fieldlist = array('date', 'author', 'title', 'time', 'email');
	if (!$in_form) {
		$news['text'] = en_nl2br($news['text']);
		$news['text'] = str_replace(',', '&komma;', $news['text']);
		foreach ($fieldlist AS $field) $news[$field] = str_replace(',', '&komma;', $news[$field]);
	} else {
  	$fieldlist[] = 'text';
		foreach ($fieldlist AS $field) $news[$field] = htmlentities(str_replace('&komma;', ',', $news[$field]));
	}
	if (!$do_edit_news) {
		$news['commentid'] = time();
	} else {
		global $id;
		$news['commentid'] = en_getcid($id);
	}
	return $news;
}

################ FUNCTION en_commentpages ################
function en_commentpages($counter) {
	global $commenttext, $en_settings, $cmtext, $id;
	if ($counter > $en_settings['maxcomments']) {
		$pagesbits = pages($counter, 1, 3, $en_settings['maxcomments'], '$_SERVER[PHP_SELF]?action=comments&amp;id=' . $id . '&amp;number=$pagenumber', 1, 0, 0);
		eval ('$commenttext .= "' . en_gettemplate('news_commentpages') . '";');
	}
}

################ FUNCTION en_commentoutput ###############
function en_commentoutput($line, $singlecomment = false) {
	global $en_settings, $en_commentscheme, $design, $ci, $id;

	$comment = en_getdata($line, $en_commentscheme);
	$comment['author'] = str_replace('&komma;', ',', $comment['author']);
	$comment['date'] = str_replace('&komma;', ',', $comment['date']);
	$comment['author'] = htmlentities($comment['author']);
	$comment['email']  = str_replace('&komma;', ',', $comment['email']);
	$comment['email']  = htmlentities($comment['email']);
	$comment['text']   = wordwrap($comment['text'], 50, '  ', 1);
	$comment['text']   = str_replace('&komma;', ',', $comment['text']);
	$comment['text']   = $en_settings['html'] == 'no' ? htmlentities($comment['text']) : en_htmlentities_leavetags($comment['text']);
	if ($en_settings['bbcomm'] == 'yes') $comment['text'] = bbcode($comment['text']);
	$comment['text']   = preg_replace('#(&lt;|<)br\s*/?(>|&gt;)#i', '<br />', $comment['text']); // Fix bad <br />-Tags

	if (!$singlecomment) {
		if ($comment['ip']) {
			eval ('$ipanddeletelink = "' . en_gettemplate('comments_ip') . '";');
		} else {
			$ipanddeletelink = '';
		}
		eval ('$ipanddeletelink .= "' . en_gettemplate('comments_deletelink') . '";');
	} else {
		$ipanddeletelink = '';
	}

	eval ('$text = "' . en_gettemplate('comments_text') . '";');
	return $text;
}

################# FUNCTION en_newsoutput #################
function en_newsoutput($news, $options = NEWS_ALLOPTIONS) {
	global $design, $commenttext, $commenteditlink, $en_settings, $en_paths, $id;

	$fieldlist = array('date', 'author', 'time', 'email');
	foreach ($fieldlist AS $field)
		$news[$field] = htmlentities(str_replace('&komma;', ',', $news[$field]));

	$news['title'] = en_htmlentities_leavetags(str_replace('&komma;', ',', $news['title']));
	$news['text']  = en_htmlentities_leavetags(str_replace('&komma;', ',', $news['text']));
	$news['text']  = bbcode($news['text']);
	if (($options & NEWS_ADDMORELINK) AND $en_settings['addmore_minchars'] > 0) {
		// replace linebreaks and <br />-tags with spaces
		$temp['text'] = preg_replace('#((&lt;|<)br\s*/?(>|&gt;)|\n)#i', ' ', $news['text']);
		// strip all remaining tags
		$temp['text'] = en_strip_tags($temp['text']);
		if (strlen($temp['text']) > $en_settings['addmore_minchars']) {
			eval ('$morelink = "' . en_gettemplate('news_showmore_link') . '";');
			eval ('$lastwordreplace = "' . en_gettemplate('news_showmore_lastwordreplace') . '";');
			$news['text'] = preg_replace('#\s+[^\s]*$#i', $lastwordreplace, substr($temp['text'], 0, $en_settings['addmore_displaychars']));
		}
	}
	if($options & NEWS_ADDFOOTER) {
		if ($commenteditlink != '') $commenttext = $commenteditlink;
		$icons = '';
		if ($options & NEWS_SHOWICONS) {
			if ($en_settings['addcomments'] == 'yes' OR $en_settings['mailnews'] == 'yes' OR $en_settings['archive']) {
				if ($en_settings['printview'] == 'yes') eval ('$icons .= "' . en_gettemplate('news_icons_printer') . '";');
				if ($en_settings['mailnews']  == 'yes') eval ('$icons .= "' . en_gettemplate('news_icons_mail') . '";');
				if ($en_settings['archive']) eval ('$icons .= "' . en_gettemplate('news_icons_archive') . '";');
				if ($icons != '') {
					eval ('$seperator = "' . en_gettemplate('news_icons_seperator') . '";');
					$icons = ($en_settings['addcomments'] == 'yes' ? $seperator : '') . chop($icons);
				} else {
					eval ('$icons = "' . en_gettemplate('news_icons_noicons') . '";');
				}
			}
		}
		eval ('$newsfooter = "' . en_gettemplate('news_footer') . '";');
	} else {
		$newsfooter = '';
	}
	if($options & NEWS_ADDHEADER) eval ('$newsheader = "' . en_gettemplate('news_header') . '";');
	eval ('$newsbody = "' . en_gettemplate('news_body') . '";');
	eval ('$output = "' . en_gettemplate('news_main') . '";');
	return $output;
}

?>
